%{!?python_sitearch: %define python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

Name:           python-storm
Version:        0.13
Release:        2%{?dist}
Summary:        An object-relational mapper (ORM) for Python

Group:          Development/Languages
License:        LGPLv2+
URL:            https://storm.canonical.com/
Source0:        https://launchpad.net/storm/trunk/%{version}/+download/storm-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# C extension now compiled by default
#BuildArch:      noarch
BuildRequires:  python-devel python-setuptools
# needed for unit tests
BuildRequires:  python-sqlite2
Requires:       python-storm-backend = %{version}-%{release}

%description
Storm is an object-relational mapper (ORM) for Python developed at
Canonical. The project has been in development for more than a year
for use in Canonical projects such as [WWW] Launchpad, and has
recently been released as an open-source product.

Highlights:

 * Clean and lightweight API offers a short learning curve and
   long-term maintainability.
 * Storm is developed in a test-driven manner. An untested line of
   code is considered a bug.
 * Storm needs no special class constructors, nor imperative base
   classes.
 * Storm is well designed (different classes have very clear
   boundaries, with small and clean public APIs).
 * Designed from day one to work both with thin relational databases,
   such as SQLite, and big iron systems like PostgreSQL and MySQL.
 * Storm is easy to debug, since its code is written with a KISS
   principle, and thus is easy to understand.
 * Designed from day one to work both at the low end, with trivial
   small databases, and the high end, with applications accessing
   billion row tables and committing to multiple database backends.
 * It's very easy to write and support backends for Storm (current
   backends have around 100 lines of code).

%package    sqlite
Summary:    SQLite backend for %{name}
Group:      Development/Libraries
Provides:   %{name}-backend = %{version}-%{release}
Requires:   %{name} = %{version}-%{release}
Requires:   python-sqlite2

%description sqlite
The %{name}-sqlite package contains the SQLite database backend for
%{name}.

%package    mysql
Summary:    MySQL backend for %{name}
Group:      Development/Libraries
Provides:   %{name}-backend = %{version}-%{release}
Requires:   %{name} = %{version}-%{release}
Requires:   MySQL-python

%description mysql
The %{name}-mysql package contains the MySQL database backend for
%{name}.

%package    postgresql
Summary:    PostgreSQL backend for %{name}
Group:      Development/Libraries
Provides:   %{name}-backend = %{version}-%{release}
Requires:   %{name} = %{version}-%{release}
Requires:   python-psycopg2

%description postgresql
The %{name}-postgresql package contains the PostgreSQL database
backend for %{name}.


%prep
%setup -q -n storm-%{version}


%build
%{__python} setup.py build


%check
./test


%install
rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT

 
%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc LICENSE NEWS README TODO tests/tutorial.txt
%exclude %{python_sitearch}/storm/cextensions.c
%exclude %{python_sitearch}/storm/databases/mysql.*
%exclude %{python_sitearch}/storm/databases/sqlite.*
%exclude %{python_sitearch}/storm/databases/postgres.*
%{python_sitearch}/storm*

%files sqlite
%defattr(-,root,root,-)
%{python_sitearch}/storm/databases/sqlite.*

%files mysql
%defattr(-,root,root,-)
%{python_sitearch}/storm/databases/mysql.*

%files postgresql
%defattr(-,root,root,-)
%{python_sitearch}/storm/databases/postgres.*


%changelog
* Mon Sep  1 2008 Michel Salim <salimma@fedoraproject.org> - 0.13-2
- Add build dependency on python-sqlite2, for unit testing

* Sat Aug 30 2008 Michel Salim <salimma@fedoraproject.org> - 0.13-1
- Update to 0.13

* Mon Jul 14 2008 Michel Salim <salimma@fedoraproject.org> - 0.12-2
- Run unit tests
- Exclude database backends from main package
- Set file attributes for subpackages

* Wed Jun 18 2008 Michel Salim <salimma@fedoraproject.org> - 0.12-1
- Update to 0.12

* Sun Jan 27 2008 Michel Salim <salimma@fedoraproject.org> - 0.11-1
- Initial Fedora package
